
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

//Írd fájlba a kimenetet (PrintWriter).
//Ügyelj arra, hogy a fájlt zárd is be a kiírások végén.
// Készíts olyan metódust, amely a println működését utánozza: a paraméterként kapott szöveget karakterenként írja ki, és még egy sorvégét utána. Próbáld ki a fenti kiíratásokat az új metódussal.

public class ThreadSolutions {
	public static void main(String[] args) {
		// 🐶
		long num = 1234L;
		float f = num;
		System.out.println(Integer.MAX_VALUE);
		System.out.println(Integer.MIN_VALUE);
		System.out.println(Long.MAX_VALUE);
		System.out.println(Long.MIN_VALUE);
		System.out.println(Byte.MAX_VALUE);
		System.out.println(Byte.MIN_VALUE);
		System.out.printf("%308f\n", Double.MAX_VALUE);
		float biggest = Long.MAX_VALUE;
		System.out.printf("%18f\n", biggest);
		System.out.println((char)('a'-48));
		
//		task1(new PrintWriter(System.out));
//		task1b();
//		task2();
	}

	private static void task2() {
		try (
			// erőforrás / resource
			var pw = new PrintWriter("out.txt");
		) {
			var threads = task1(pw);
			for (Thread t : threads) {
				t.join();
			}
		} catch (InterruptedException | IOException e) {
			// .................
		}
		
		System.out.println("done");
	}

	private static List<Thread> task1(PrintWriter out) {
		String[] strings = new String[] { "a", "b", "c" };
		String[] strings2 = { "a", "b", "c" };
		var strings3 = "a b c fds afd afs dasf".split(" ");

		List<Thread> threads = new ArrayList<>();
		
		for (String string : strings3) {
			Thread thread = new Thread(() -> {
				for (int i = 0; i < 100_000; i++) {
					out.println(string + " " + i);
				}
			});
			thread.start();
			threads.add(thread);
		}

		return threads;
	}
	
	private static void task1b() {
		String[] strings = new String[] { "a", "b", "c" };
		String[] strings2 = { "a", "b", "c" };
		var strings3 = "a b c fds afd afs dasf".split(" ");
		
		for (String string : strings3) {
			new Thread(new MyRunnableImpl(string)).start();
		}
		
	}
}

class MyRunnableImpl implements Runnable {
	private String string;

	public MyRunnableImpl(String string) {
		this.string = string;
	}
	
	@Override
	public void run() {
		for (int i = 0; i < 100_000; i++) {
			System.out.println(string + " " + i);
		}
	}
	
}

