// abc
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Scanner;

public class UsingResources {
	public static void main(String[] args) throws Exception {
		// effectively final
//		int counter = 0;
		int[] counter = { 0 };
		Thread thread1 = new Thread(() -> {
			for (int i = 0; i < 100_000; i++) {
//				System.out.println(counter);
//				++counter;
				synchronized (counter) {
					++counter[0];
				}
			}
		});

		Thread thread2 = new Thread(() -> {
			for (int i = 0; i < 100_000; i++) {
//				System.out.println(counter);
//				++counter;
				synchronized (counter) {
					++counter[0];
				}
			}
		});

		thread1.start();
		thread2.start();
		
		thread1.join();
		thread2.join();

		System.out.println(Arrays.toString(counter));
		System.out.println(counter[0]);
	}
	
	public static void main2(String[] args) throws Exception {
		// immutable
		String s = "abc";
		String s2 = "abc";
		String s3 = new String("abc");
		String s4 = readStringFromFile();
		System.out.println(s.equals(s2));
		System.out.println(s2.equals(s));
		
		System.out.println(new UsingResources() == new UsingResources());

		System.out.println(s == s2);
		System.out.println(s2 == s);
		System.out.println("----------------");
		System.out.println(s == s3);
		System.out.println(s == s4);
		System.out.println(s3 == s4);
		System.out.println(s.equals(s3));
		System.out.println(s.equals(s4));
		System.out.println(s3);
		System.out.println(s4);
	}

	private static String readStringFromFile() throws FileNotFoundException {
		Scanner hack = new Scanner(new File("src/UsingResources.java"));
		hack.next();
		String s4 = hack.next();
		return s4;
	}

	public static void main3(String[] args) {
		Object myLock = new Object();
		
		Thread thread = new Thread(() -> {
//			synchronized (myLock) {
				for (int i = 0; i < 100_000; i++) {
//					System.out.println("hello");
					myPrintln("aaaaaaaaaaaaaaaaaaaaaaa", myLock);
				}
//			}
		});
//		thread.setPriority(1);
//		thread.run();
		thread.start();

		Thread thread2 = new Thread(() -> {
//			synchronized (myLock) {
				for (int i = 0; i < 100_000; i++) {
					myPrintln("bbbbbbbbbbbbbbbbbbbbbbb", myLock);
				}
//			}
		});
//		thread2.setPriority(9);
//		thread2.run();
		thread2.start();

//		System.out.print((int)'\r');
//		System.out.print((int)'\n');
	}

	static void myPrintln(String s, Object myLock) {
		// monitor
		// lock / zr
//		synchronized (System.out) {
//		synchronized (s) {
//		synchronized ("adsfadsa") {
//		synchronized (new Object()) {
//		synchronized (Integer.class) {
//		synchronized (int[].class) {
//		synchronized (myLock) {
			for (char c : s.toCharArray()) {
//				synchronized (myLock) {
					System.out.print(c);
//				}
			}
			System.out.println();
//		}

//		System.out.print("\n");
//		System.out.print("\r");
//		System.out.printf("%d %x %s\n%n", i, j, s);
//		System.out.println(System.lineSeparator());
	}
}
